#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=..\..\..\Pictures\Symbole\Programm.ico
#AutoIt3Wrapper_outfile=Directory Indexer.exe
#AutoIt3Wrapper_UseX64=n
#AutoIt3Wrapper_Res_Comment=Indexes a given directory and calculates the file sizes. Can also count the lines.
#AutoIt3Wrapper_Res_Description=Directory Indexer
#AutoIt3Wrapper_Res_Fileversion=0.2.0.0
#AutoIt3Wrapper_Res_LegalCopyright=Free for personal and commercial use.
#AutoIt3Wrapper_Res_Language=1033
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#include <file.au3>

$_PROGNAME = "Directory Indexer"
$_PROGVER = "0.2"
$_PROGAUTHOR = "jangxx"

Global $folderPath = FileSelectFolder("select folder to index","")
if ($folderPath = "") Then Exit
$helptext = 'Format:'&@CRLF& 'optionname1:option1-optionname2:option2-...' &@CRLF&@CRLF& _
'Example:'&@CRLF&'type:txt-size:b' &@CRLF&@CRLF& _
'Available options:'&@CRLF& _
'type - filetype for filtering (default:*)'&@CRLF& _
'round - the size is rounded to this (default:2)'&@CRLF& _
'size - the format of the size [b,kb,mb,gb,tb] (default:mb)'&@CRLF& _
'folder - wether or not folder sizes should be calculated or all subfolders should be indexed [0,1,2] (default:0)'&@CRLF& _
'lines - count the lines of files [0,1] (default:0)'&@CRLF& _
'output - display the progress [0,1] (default:1)'
$options = InputBox("Enter options",$helptext,"","",340,300)

$fileType = ""
$sizeOption = ""
$roundOption = ""
$folderOption = ""
$lineOption = ""
$outputOption = ""

if $options <> "" Then
	$options = StringSplit($options,"-")
	For $k = 1 to UBound($options) - 1
		$temp_opt = StringSplit($options[$k],":")
		if not @error Then
		Switch $temp_opt[1]
			case "type"
				$fileType = $temp_opt[2]
			case "round"
				$roundOption = $temp_opt[2]
			case "size"
				$sizeOption = $temp_opt[2]
			case "folder"
				$folderOption = $temp_opt[2]
			case "lines"
				$linesOption = $temp_opt[2]
			case "output"
				$outputOption = $temp_opt[2]
		EndSwitch
	EndIf
	Next
EndIf

Global $fileType, $roundOption, $sizeOption, $folderOption, $linesOption
if ($fileType = "") Then $fileType = "*"
if ($roundOption = "") Then $roundOption = 2
if ($sizeOption = "") Then $sizeOption = "mb"
if ($folderOption = "") Then $folderOption = 0
if ($linesOption = "") Then $linesOption = False
if ($outputOption = "") Then $outputOption = True

$hFilesearch = FileFindFirstFile($folderPath & '\*.' & $fileType)
$files = ""

If ($outputOption = True) Then
	Global $outputPopup_title = $_PROGNAME & " " & $_PROGVER
	Global $outputPopup = SplashTextOn($outputPopup_title, "Starting the scan..",500,100,Default,Default,2+4+16+32)
EndIf

While 1
	$file = FileFindNextFile($hFilesearch)
	if @error Then ExitLoop
	If ($outputOption = True) Then ControlSetText($outputPopup_title, "", "Static1", "Indexing: " & $file)
	$files = $files & $file & "|";" - " & Round(FileGetSize($folderPath & "\" & $file) / 1024 / 1024 / 1024,2) & " GB" & @CRLF
	if StringInStr(FileGetAttrib($folderPath & "\" & $file),"D") and $folderOption = "2" Then
		$files = $files & findFile($folderPath, $file)
	EndIf
WEnd
$files = StringTrimRight($files,1)

$fileContents = $_PROGNAME & " " & $_PROGVER & " by " & $_PROGAUTHOR & @CRLF
$fileContents = $fileContents & "Contents of " & '"' & $folderPath & '"' & " type: *." & $fileType & @CRLF & @CRLF

$_files = StringSplit($files,"|")

Dim $files[Ubound($_files) - 1][3]
For $i = 0 to Ubound($files) - 1
	$files[$i][0] = $_files[$i + 1]
Next

$len = 0
$len_s = 0
$len_l = 0
$linecount = 0
$complsize = 0
For $i = 0 to UBound($files) - 1
	If ($outputOption = True) Then ControlSetText($outputPopup_title, "", "Static1", "Processing (" & $i & "/" & (UBound($files) - 1) & "): " & $files[$i][0])
	$temp_len = StringLen($files[$i][0])
	$files[$i][1] = _size($folderPath,$files[$i][0])
	$complsize += FileGetSize($folderPath & "\" & $files[$i][0])
	If ($linesOption = "1") Then
		$files[$i][2] = _lines($folderPath,$files[$i][0])
		$linecount += $files[$i][2]
	EndIf
	$temp_len_s = StringLen($files[$i][1])
	If ($linesOption = "1") Then $temp_len_l = StringLen($files[$i][2])
	If $temp_len > $len Then $len = $temp_len
	If $temp_len_s > $len_s Then $len_s = $temp_len_s
	If $linesOption = "1" and $temp_len_l > $len_l Then $len_l = $temp_len_l
Next

If ($outputOption = True) Then ControlSetText($outputPopup_title, "", "Static1", "Creating file contents..")

$fileContents = $fileContents & "name" & _whitespaces($len) & "|" & "size" & _whitespaces($len_s) & "|"
If ($linesOption = "1") Then $fileContents = $fileContents & "lines" & _whitespaces($len_l - 1) & "|"
$fileContents = $fileContents & @CRLF & _line($len + 4) & "|" & _line($len_s + 4) & "|"
If ($linesOption = "1") Then $fileContents = $fileContents & _line($len_l + 4) & "|"
$fileContents = $fileContents & @CRLF

For $i = 0 to UBound($files) - 1
	$fileContents = $fileContents & $files[$i][0] & _whitespaces(($len + 4) - StringLen($files[$i][0])) & "|" & $files[$i][1] & _whitespaces(($len_s + 4) - StringLen($files[$i][1])) & "|"
	If ($linesOption = "1") Then $fileContents = $fileContents & $files[$i][2] & _whitespaces(($len_l + 4) - StringLen($files[$i][2])) & "|"
	$fileContents = $fileContents & @CRLF
Next

$fileContents = $fileContents & @CRLF & "Files/Folders: " & UBound($files)
$fileContents = $fileContents & @CRLF & "Size: " & _formatsize($complsize,$sizeOption,$roundOption)
If ($linesOption = "1") Then $fileContents = $fileContents & @CRLF & "Lines: " & $linecount

If ($outputOption = True) Then
	SplashOff()
EndIf

$savePath = FileSaveDialog("Save file...","Desktop","Text files (*.txt)",2 + 16,"index.txt")
$fOpen = FileOpen($savePath,2)
FileWrite($fOpen,$fileContents)
FileClose($fOpen)
Exit

Func findFile($path, $dir)
	$_files = ""
	$_findfile = FileFindFirstFile($path & "\" & $dir & "\*." & $fileType)
	While 1
		$_file = FileFindNextFile($_findfile)
		if @error Then ExitLoop
		If ($outputOption = True) Then ControlSetText($outputPopup_title, "", "Static1", "Indexing: " & $dir & "\" & $file)
		$_files = $_files & $dir & "\" & $_file & "|"
		if StringInStr(FileGetAttrib($path & "\" & $file),"D") Then
			$_files = $_files & findFile($path, $dir & "\" & $_file)
		EndIf
	WEnd
	Return $_files
EndFunc

Func _lines($path,$filename)
	Return _FileCountLines($path & "\" & $filename)
EndFunc

Func _size($path,$filename)
	If StringInStr(FileGetAttrib($path & "\" & $filename),"D") Then
		If $folderOption = "1" Then
			Return "FOLDER - " & _formatsize(DirGetSize($path & "\" & $filename),$sizeOption,$roundOption)
		Else
			Return "FOLDER"
		EndIf
	Else
		Return _formatsize(FileGetSize($path & "\" & $filename),$sizeOption,$roundOption)
	EndIf
EndFunc

Func _formatsize($size,$format = "mb",$round = 2)
	switch $format
		case "b"
			$return = Round($size,$round) & " B"
		case "kb"
			$return = Round($size / 1024,$round) & " KB"
		case "mb"
			$return = Round($size / 1024 / 1024,$round) & " MB"
		case "gb"
			$return = Round($size / 1024 / 1024 / 1024,$round) & " GB"
		case "tb"
			$return = Round($size / 1024 / 1024 / 1024 / 1024,$round) & " TB"
	EndSwitch
	Return $return
EndFunc

Func _line($len)
	local $return = ""
	for $j = 1 to $len
		$return = $return & "="
	Next
	Return $return
EndFunc

Func _whitespaces($number)
	local $return = ""
	for $j = 1 to $number
		$return = $return & " "
	Next
	Return $return
EndFunc